#version 330  core
#extension GL_ARB_explicit_uniform_location : enable

in vec4 prev_position;
in vec4 position;

layout(location = 9) uniform sampler2D colorMap;
layout(location = 43) uniform float blurScale;

out vec4 out_color;

void main(void) {

	//int samples = 8;
	//float weight[8] = float[] (8.0f/36.0f,7.0f/36.0f,6.0f/36.0f,5.0f/36.0f,4.0f/36.0f,3.0f/36.0f,2.0f/36.0f,1.0f/36.0f);

	int samples = 5;
	float weight[5] =float[] (5.0f/15.0f,4.0f/15.0f,3.0f/15.0f,2.0f/15.0f,1.0f/15.0f);

	vec2 p = position.xy / position.w;
	vec2 prev_p = prev_position.xy / prev_position.w;
	vec2 screenVelocity = (prev_p-p) * blurScale; 
	out_color = vec4(0,0,0,1);

	vec2 screenPos = p*0.5+vec2(0.5,0.5);
	//ivec2 screenSize = textureSize(colorMap,0);
	//vec2 screenPos = vec2(gl_FragCoord.x/screenSize.x,gl_FragCoord.y/screenSize.y);

	// sample scene texture along direction of motion
	vec4 texColor; 
	float stepsize = 1.0f/(samples-1);
	for (int i=0; i<samples; i++) {
		texColor = texture(colorMap, screenPos);
		screenPos += stepsize * screenVelocity;
		out_color += texColor * weight[i];
	}


}