#version 330 core
#extension GL_ARB_explicit_uniform_location : enable

layout(location = 1) in vec4 in_position;
layout(location = 2) in vec3 in_normal;

layout(location = 5) uniform mat4 mvpMatrix;
layout(location = 31) uniform mat4 prev_mvpMatrix; 
layout(location = 10) uniform mat3 normalMatrix;
layout(location = 13) uniform mat4 modelMatrix; 
layout(location = 32) uniform mat4 prev_modelMatrix;

out vec4 prev_position;
out vec4 position;

void main(void) {

	// calculate clip space positions
	position = mvpMatrix * in_position;
	prev_position = prev_mvpMatrix * in_position;
	gl_Position = position;

	/*
	// transform previous and current pos to world space  
	position = modelMatrix * in_position;
	prev_position = prev_modelMatrix * in_position;

	// calculate world space motion vector 
	vec3 motionVector= position.xyz-prev_position.xyz;

	// transform normal to world space
	vec3 normal = normalMatrix * in_normal;

	// calculate clip space positions
	position = mvpMatrix * in_position;
	prev_position = prev_mvpMatrix * in_position;

	// choose previous or current position based
	// on dot product between motion vector and normal (in world space))
	vec4 positionStretch;
	if (dot(normalize(motionVector), normalize(normal)) > 0) {  //TODO check for > 0 oder < 0 ?
		positionStretch = position; 
	} else {
		positionStretch = prev_position;
	}
	gl_Position = positionStretch;

	*/

}