// Geometry Shader  file "environmentCubeShader.geom"

#version 330 core
#extension GL_ARB_explicit_uniform_location : enable

layout(triangles) in;
layout(triangle_strip) out;
layout(max_vertices = 18) out;

//view projection matrices (for each cube face)
layout(location = 33) uniform mat4 cubemapMatrix1;
layout(location = 34) uniform mat4 cubemapMatrix2;
layout(location = 35) uniform mat4 cubemapMatrix3;
layout(location = 36) uniform mat4 cubemapMatrix4;
layout(location = 37) uniform mat4 cubemapMatrix5;
layout(location = 38) uniform mat4 cubemapMatrix6;

//in mat3 vlightIntensity[];	//intensity of light, includes color
in mat3 vlightDirection[];	//direction vertex to light
//in vec3 vcameraDirection[];  //direction vertex to camera
in vec3 vnormal[];		   //transformed normal vector of vertex
in vec3 vcolor[];
in vec2 vtexCoords[];
in vec4 vSM_tex_coords1[];
//in vec4 vSM_tex_coords2[];
//in vec4 vSM_tex_coords3[];

//out mat3 lightIntensity;	//intensity of light, includes color
out mat3 lightDirection;	//direction vertex to light
//out vec3 cameraDirection;  //direction vertex to camera
out vec3 normal;		   //transformed normal vector of vertex
out vec2 texCoords;
out vec3 color;
out vec4 SM_tex_coords1;
//out vec4 SM_tex_coords2;
//out vec4 SM_tex_coords3;


void main(void) {

	mat4 matrices[6];
	matrices[0] = cubemapMatrix1;
	matrices[1] = cubemapMatrix2;
	matrices[2] = cubemapMatrix3;
	matrices[3] = cubemapMatrix4;
	matrices[4] = cubemapMatrix5;
	matrices[5] = cubemapMatrix6;
	
	//iterate over the 6 cubemap faces
	for(gl_Layer=0; gl_Layer<6; ++gl_Layer) {

		for(int tri_vert=0; tri_vert<3; tri_vert++) {

		
			//cameraDirection=vcameraDirection[tri_vert];
			//lightIntensity=vlightIntensity[tri_vert];
			lightDirection = vlightDirection[tri_vert];
			normal=vnormal[tri_vert];
			SM_tex_coords1=vSM_tex_coords1[tri_vert];
			//SM_tex_coords2=vSM_tex_coords2[tri_vert];
			//SM_tex_coords3=vSM_tex_coords3[tri_vert];
			texCoords = vtexCoords[tri_vert];
			color = vcolor[tri_vert];
			

			vec4 world_pos = gl_in[tri_vert].gl_Position;
			gl_Position = matrices[gl_Layer] * world_pos;
			EmitVertex();
		}
		EndPrimitive();
	}
	


}

