// Vertex Shader  file "particleShader.vert"

#version 330 core
#extension GL_ARB_explicit_uniform_location : enable

//Shader for particle systems

layout(location = 1) in vec3 in_position;
layout(location = 3) in vec4 in_color;

layout(location = 5) uniform mat4 mvpMatrix;
layout(location = 30) uniform float shininess; //(=size of particle) 12
layout(location = 14) uniform vec3 cameraPos;


out vec4 color;

void main(void)
{

	color = in_color;

	float dist = length(cameraPos-in_position);

	gl_PointSize = shininess * sqrt(1/dist);

	if(gl_PointSize < 4.0)
		color = smoothstep(0.0, 4.0, gl_PointSize) * color;

	gl_Position = mvpMatrix * vec4(in_position,1);
}
